import checkers.nullness.quals.*;

public class Varargs {

    public void test(@NonNull Object @NonNull... o) {
        for (@NonNull Object p : o)
            System.out.println(p);
    }

    public void test2(Object o1, Object o2) {
        System.out.println(o1);
        System.out.println(o2);
    }

    public void testVarargs() {
        test("foo", "bar", "baz");
    }

    public void testVarargsNoArgs() {
        test();
    }

    public void testNonVarargs() {
        test2("foo", "bar");
    }

    public void format1(java.lang.String a1, @Nullable java.lang.Object... a2) {
        int x = a2.length;           // no warning
        for (@NonNull Object p : a2) // warning
            System.out.println(p);
    }

    public void format2(java.lang.String a1, java.lang.Object @Nullable ... a2) {
        int x = a2.length;           // warning
        for (@NonNull Object p : a2) // no warning
            System.out.println(p);
    }

}
